"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (t, stack) {
  var bluebird = t.identifier("Promise");

  return {
    enter: function enter(path) {
      var node = path.node;

      if (node.async === true) {
        stack.push(node);
      }
    },
    exit: function exit(path) {
      var node = path.node;

      if (node && !node[REPLACED] && node.async === true) {
        var fn = stack.pop();
        // generators use 'coroutine' helper, other wise just 'method'
        var methodName = fn.generator ? "coroutine" : "method";
        var asyncWrap = t.memberExpression(bluebird, t.identifier(methodName));

        fn[REPLACED] = true;
        fn.async = false; // prevent recursive visits
        path.replaceWith(t.callExpression(asyncWrap, [fn]));
      }
    }
  };
};

var REPLACED = Symbol();