'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (_ref) {
  var t = _ref.types;

  return {
    visitor: {

      FunctionExpression: (0, _functionTransform2.default)(t, stack),
      ArrowFunctionExpression: (0, _functionTransform2.default)(t, stack),

      AwaitExpression: function AwaitExpression(path) {
        var node = path.node;

        var arg = node.argument;
        path.replaceWith(t.yieldExpression(arg));

        // if there's an 'await', we'll turn the function into a generator
        var fn = stack[stack.length - 1];
        if (fn) {
          // assert that 'await' is used in async methods only
          t.assertFunctionExpression(fn, { async: true });
          fn.generator = true;
        }
      }
    }
  };
};

var _functionTransform = require('./functionTransform');

var _functionTransform2 = _interopRequireDefault(_functionTransform);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var stack = [];